package javassist.gluonj.weave;

import javassist.CtBehavior;
import javassist.CtConstructor;
import javassist.gluonj.WeaveException;
import javassist.gluonj.pc.PcPattern;
import javassist.gluonj.pc.WithinPc;

/**
 * A super class of CallMatcher, FieldMatcher, ...
 */
public abstract class ExprMatcher extends Matcher {
    private String withinClass;
    private String withinMethodName, withinMethodSignature;

    protected ExprMatcher(CtBehavior where) {
        super();
        withinClass = where.getDeclaringClass().getName();
        withinMethodName = where.getName();
        withinMethodSignature = where.getSignature();
        if (where instanceof CtConstructor)
            if (((CtConstructor)where).isConstructor())
                withinMethodName = AdviceWeaver.CONSTRUCTOR;
    }

    public void visit(WithinPc pc) throws WeaveException {
        PcPattern pp = pc.getPattern();
        if (pp.isMethod())
            result = pp.matchMethod(withinClass, withinMethodName, withinMethodSignature);
        else
            result = pp.matchClass(withinClass);
    }
}
